VERSION 5.00
Begin VB.UserControl BusyBoxCtrl 
   ClientHeight    =   6135
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   8565
   ScaleHeight     =   6135
   ScaleWidth      =   8565
   Begin VB.Frame frmMediaLibrary 
      Caption         =   "Media Library"
      Height          =   1335
      Left            =   4380
      TabIndex        =   13
      Top             =   2820
      Width           =   3915
      Begin VB.CommandButton btnWalkViewSchemes 
         Caption         =   "Walk View Schemes (takes a while)"
         Height          =   375
         Left            =   240
         TabIndex        =   15
         Top             =   780
         Width           =   3495
      End
      Begin VB.CommandButton btnListViewSchemes 
         Caption         =   "List View Schemes"
         Height          =   375
         Left            =   240
         TabIndex        =   14
         Top             =   360
         Width           =   3495
      End
   End
   Begin VB.Frame frmPlayingNow 
      Caption         =   "Playing Now"
      Height          =   1335
      Left            =   4380
      TabIndex        =   10
      Top             =   1320
      Width           =   3915
      Begin VB.CommandButton btnPlayRandomTracks 
         Caption         =   "Play 10 Random Tracks"
         Height          =   375
         Left            =   300
         TabIndex        =   12
         Top             =   780
         Width           =   3375
      End
      Begin VB.CommandButton btnListPlayingNow 
         Caption         =   "List Playing Now Files"
         Height          =   375
         Left            =   300
         TabIndex        =   11
         Top             =   360
         Width           =   3375
      End
   End
   Begin VB.Frame frmPlaylists 
      Caption         =   "Playlists"
      Height          =   1335
      Left            =   240
      TabIndex        =   8
      Top             =   2820
      Width           =   3915
      Begin VB.CommandButton btnListPlaylists 
         Caption         =   "List Playlists"
         Height          =   375
         Left            =   180
         TabIndex        =   9
         Top             =   540
         Width           =   3555
      End
   End
   Begin VB.Frame frmStatus 
      Caption         =   "Status"
      Height          =   1755
      Left            =   240
      TabIndex        =   6
      Top             =   4260
      Width           =   8055
      Begin VB.ListBox lbStatus 
         Height          =   1230
         Left            =   180
         TabIndex        =   7
         Top             =   360
         Width           =   7695
      End
   End
   Begin VB.Frame frmMixer 
      Caption         =   "Mixer"
      Height          =   1335
      Left            =   240
      TabIndex        =   1
      Top             =   1320
      Width           =   3915
      Begin VB.CommandButton btnVolumeSet 
         Caption         =   "Set"
         Height          =   315
         Left            =   2460
         TabIndex        =   5
         Top             =   780
         Width           =   1215
      End
      Begin VB.CommandButton btnVolumeGet 
         Caption         =   "Get"
         Height          =   315
         Left            =   960
         TabIndex        =   4
         Top             =   780
         Width           =   1275
      End
      Begin VB.HScrollBar scrollVolume 
         Height          =   315
         LargeChange     =   10
         Left            =   960
         Max             =   100
         TabIndex        =   3
         Top             =   300
         Width           =   2715
      End
      Begin VB.Label lblVolume 
         Caption         =   "Volume:"
         Height          =   195
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Width           =   615
      End
   End
   Begin VB.Label lblTitle 
      Alignment       =   2  'Center
      Caption         =   "Media Jukebox Interface Plugin - Busy Box"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   915
      Left            =   2100
      TabIndex        =   0
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "BusyBoxCtrl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Public g_MJ As MediaJukebox.MJAutomation
Public Function Init(ByVal MediaJukebox As Object)
    
    ' set the global Media Jukebox object on init
    ' (Media Jukebox will call this function when the plugin starts)
    Set g_MJ = MediaJukebox
    
End Function

Private Sub btnListPlayingNow_Click()
   
   ' empty the status list
    lbStatus.Clear
    
    ' get the current playlist object
    Dim MJCurPlaylist As MediaJukebox.MJCurPlaylistAutomation
    Set MJCurPlaylist = g_MJ.GetCurPlaylist
    
    ' go through each file
    For z = 0 To MJCurPlaylist.GetNumberFiles - 1
        
        ' get the file
        Dim MJFile As MediaJukebox.MJFileAutomation
        Set MJFile = MJCurPlaylist.GetFile(z)
   
        ' add the file to the list
        lbStatus.AddItem MJFile.FileName
    
    Next z
    
End Sub

Private Sub btnListPlaylists_Click()
    
    ' empty the status list
    lbStatus.Clear
    
    ' get the playlists collection
    Dim MJPlaylists As MediaJukebox.MJPlaylistsAutomation
    Set MJPlaylists = g_MJ.GetPlaylists
    
    ' go through each playlist
    For z = 0 To MJPlaylists.GetNumberPlaylists - 1
        
        ' get the playlist
        Dim MJPlaylist As MediaJukebox.MJPlaylistAutomation
        Set MJPlaylist = MJPlaylists.GetPlaylist(z)
   
        ' get the playlist's full path
        Dim strFullPath As String
        strFullPath = MJPlaylist.Path
        If (strFullPath <> "") Then
            strFullPath = strFullPath + "\"
        End If
        strFullPath = strFullPath + MJPlaylist.Name
        
        ' add the playlist to the list
        lbStatus.AddItem strFullPath
    
    Next z
    
End Sub

Private Sub btnListViewSchemes_Click()

   ' empty the status list
    lbStatus.Clear
    
    ' get the root scheme object
    Dim MJScheme As MediaJukebox.MJSchemeAutomation
    Set MJScheme = g_MJ.GetViewScheme("Media Library")
    
    ' go through and list the names of all the child schemes
    For z = 0 To MJScheme.GetNumberSchemes - 1
    
        lbStatus.AddItem MJScheme.GetSchemeName(z)
    
    Next z
    
End Sub

Private Sub btnPlayRandomTracks_Click()

    ' empty the status list
    lbStatus.Clear
    
    ' randomize
    Randomize
    
    ' get the current playlist object
    Dim MJCurPlaylist As MediaJukebox.MJCurPlaylistAutomation
    Set MJCurPlaylist = g_MJ.GetCurPlaylist
    
    ' remove all the existing tracks
    MJCurPlaylist.RemoveAllFiles
    
    ' add 10 random files
    
    ' get all the files in the library
    Dim MJFiles As MediaJukebox.MJFilesAutomation
    Set MJFiles = g_MJ.Search("")
    
    ' go through and add 10 files
    For z = 1 To 10
        
        ' pick a random file
        Dim nFileIndex As Integer
        nFileIndex = Rnd() * MJFiles.GetNumberFiles()
        
        ' make sure the index is in bounds
        If (nFileIndex >= 0 And nFileIndex < MJFiles.GetNumberFiles) Then
            
            ' get the file
            Dim MJFile As MediaJukebox.MJFileAutomation
            Set MJFile = MJFiles.GetFile(nFileIndex)
            
            ' add it to playing now
            MJCurPlaylist.AddFile MJFile.FileName, z - 1
        
        End If
    Next z
    
    ' set the first file to play
    MJCurPlaylist.Position = 0
    
    ' start playback
    Dim MJPlayback As MediaJukebox.MJPlaybackAutomation
    Set MJPlayback = g_MJ.GetPlayback
    MJPlayback.Play
    
    ' output status
    lbStatus.AddItem "Playing random tracks from Media Library"
    
End Sub

Private Sub btnVolumeGet_Click()
    
    ' empty the status list
    lbStatus.Clear
    
    ' get the mixer
    Dim MJMixer As MediaJukebox.MJMixerAutomation
    Set MJMixer = g_MJ.GetMJMixer()
    
    ' set the volume slider position
    scrollVolume.Value = MJMixer.Volume
    
    ' output status
    lbStatus.AddItem "Volume Retrieved"
    
End Sub
Private Sub btnVolumeSet_Click()
    
    ' empty the status list
    lbStatus.Clear
    
    ' get the mixer
    Dim MJMixer As MediaJukebox.MJMixerAutomation
    Set MJMixer = g_MJ.GetMJMixer()
    
    ' set the volume from the slider position
    MJMixer.Volume = scrollVolume.Value

    ' output status
    lbStatus.AddItem "Volume Set"

End Sub

Private Sub WalkScheme(MJScheme As MediaJukebox.MJSchemeAutomation, ByRef nDepth As Integer)
    
    ' list the item
    Dim strOutput As String
    For z = 1 To nDepth
        strOutput = strOutput + vbTab
    Next z
    strOutput = strOutput + MJScheme.GetName
    lbStatus.AddItem strOutput

    ' go through all the child schemes
    For z = 0 To MJScheme.GetNumberSchemes() - 1
        
        ' get the child scheme
        Dim MJChildScheme As MediaJukebox.MJSchemeAutomation
        Set MJChildScheme = MJScheme.GetScheme(z)
            
        ' walk the child scheme (recursive)
        nDepth = nDepth + 1
        Call WalkScheme(MJChildScheme, nDepth)
        nDepth = nDepth - 1
        
    Next z
    
End Sub
Private Sub btnWalkViewSchemes_Click()
   
    ' empty the status list
    lbStatus.Clear
    
    ' get the root scheme object
    Dim MJRootScheme As MediaJukebox.MJSchemeAutomation
    Set MJRootScheme = g_MJ.GetViewScheme("Media Library")
    
    ' call our recursive helper function to walk the scheme
    Dim nDepth As Integer
    nDepth = 0
    Call WalkScheme(MJRootScheme, nDepth)
    
End Sub
